


/**
 * <p>Title: Simple Example </p>
 * <p>Description: Simple example to show how to use this API</p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: LAITS@GMU</p>
 * @author Peisheng Zhao
 * @version 1.0
 */
import java.util.*;
import javax.swing.*;
import laits.registry.ogc.infomodel.core.*;
import edu.gmu.laits.registry.*;

public class SimpleExample {
  public SimpleExample() {
  }
  public static void main(String[] args) {
    SimpleExample ex = new SimpleExample();
    //CSW URL
    String url = "http://geobrain.laits.gmu.edu:8099/CSWDiscovery/Query";
    int i =0;
    //To search Web Coverage Service
    ArrayList services = ex.doOGCServiceSearch(url,"Web Coverage Service");
    for(i=0;i<services.size();i++) {
      System.out.println("Service:" + ((Service)services.get(i)).getName());
    }
    //To search data within a specified bounding box
    String[] bb = {"EPSG:32618","317600","4246000","341600","4270000"};
    String[] tt = new String[2];
    String[] aa = new String[9];
    ArrayList datasets = ex.doDataSearch(url,bb,tt,aa);
    for(i=0;i<datasets.size();i++) {
      String id = ((ExtrinsicObject)datasets.get(i)).getID();
      System.out.println("dataset:" + id);
      //to search services associated with data
      services = ex.doDataServiceSearch(url,id);
      for(int j=0;j<services.size();j++) {
        System.out.println("Service:" + ((Service)services.get(j)).getName());
      }

    }

  }

  /**
   * Search OGC service
   * @param url           CSW URL
   * @param key           service query
   * @return              service list
   */
  public ArrayList doOGCServiceSearch(String url, String key) {  // s
       ArrayList alist = null;
       try {

         alist = RegistryParser.parseServiceResponse(new java.net.URL(url),RequestFactory.createRequest(key));

         if(alist.size()==0) {
           JOptionPane.showMessageDialog(new JFrame(),"No result could be found.","Insane error",JOptionPane.ERROR_MESSAGE);
           //return;
         }
       }
       catch(Exception e) {JOptionPane.showMessageDialog(new JFrame(),e.toString(),"Insane error",JOptionPane.ERROR_MESSAGE);}
       return alist;
   }

   /**
    * Search earth science data based on ECS metadata
    * @param url           CSW url
    * @param b             bouding box, b[0] is the name of spatial reference system
    *                      b[1] is minX, bbox is minY, bbox is maxX and bbox is maxY
    * @param t             production time
    * @param a             attributes
    * @return              dataset list
    */
   public ArrayList doDataSearch(String url, String[] b, String[]t, String[] a) {
                                  // pName, String iName, String plName,
                                  // String sKeyword,  String tKeyword, String dKeyword, String termKeyword,
                                  // String vKeyword, String pLevel) {
      ArrayList alist = null;
      try {
         alist =
         RegistryParser.parseDataResponse(new java.net.URL(url),RequestFactory.createRequest(b,t,a));
           //pName, iName, plName, sKeyword, tKeyword, dKeyword, termKeyword, vKeyword, pLevel));
         if(alist.size()==0) {
           JOptionPane.showMessageDialog(new JFrame(),"No result could be found.","Inasne error",JOptionPane.ERROR_MESSAGE);

         }


       }
       catch(Exception e) {JOptionPane.showMessageDialog(new JFrame(),e.toString(),"Insane error",JOptionPane.ERROR_MESSAGE);}
      return alist;

   }

   /**
    * To search services which provide specified data
    * @param url          CSW URL
    * @param dataID       data UUID
    * @return             service list
    */
   public ArrayList doDataServiceSearch(String url, String dataID) {  // s
      ArrayList alist = null;
      try {

        alist = RegistryParser.parseDataServiceResponse(new java.net.URL(url),RequestFactory.CreateDataServiceRequest(dataID));

        if(alist.size()==0) {
          JOptionPane.showMessageDialog(new JFrame(),"No result could be found.","Insane error",JOptionPane.ERROR_MESSAGE);
          //return;
        }
      }
      catch(Exception e) {JOptionPane.showMessageDialog(new JFrame(),e.toString(),"Insane error",JOptionPane.ERROR_MESSAGE);}
      return alist;
  }




}
