package edu.gmu.laits.util;

/**
 * Title:        HTTP
 * Description:  Get information through HTTP GET or POST.
 * Copyright:    Copyright (c) 2002
 * Company:      LAITS.GMU
 * @author Peisheng Zhao
 * @version 1.0
 */
import java.io.*;
import java.net.*;
public class WebData {


  /**
   * GET method
   * @param url         connection point
   * @return            input stream
   * @throws Exception
   */
 public static InputStream InGet(java.net.URL url) throws Exception {

   try {
     return url.openStream();

   }
   catch(Exception e) {System.out.println(url+ " could not be connected.");
    // e.printStackTrace();
     throw e;
   }


 }

 /**
  * POST method
  * @param url         connection point
  * @param para        post string
  * @return            input stream
  * @throws Exception
  */
 public static InputStream InPost(java.net.URL url,String para)throws Exception  {

   try {
     HttpURLConnection urlc = (HttpURLConnection)url.openConnection();
     urlc.setDoOutput(true);
     urlc.setDoInput(true);
     urlc.setAllowUserInteraction(false);
     //// Specify the content type.
     urlc.setRequestMethod("POST");
     urlc.setRequestProperty("Content-type", "text/xml");
     PrintWriter out = new PrintWriter(urlc.getOutputStream());
     out.println(para);out.flush();out.close();

     return urlc.getInputStream();
   }
   catch(Exception e) {System.out.println(url+ " could not be connected.");
     e.printStackTrace();
     throw e;}

   }
}
