package laits.registry.ogc.infomodel.core;

/**
 * Title:        RegistryObject
 * Description:  At the root of registry information model, Every registered resource is a registry object.
 * Copyright:    Copyright (c) 2002
 * Company:      LAITS.GMU
 * @author
 * @version 1.0
 */
import laits.registry.ogc.*;
import javax.xml.registry.*;
import java.util.Hashtable;

public abstract class RegistryObject {

  String m_sDescription;
  String m_sID;      // UUID
  String m_sName;
  String m_sObjectType;
  String m_sTypeString;
  Hashtable slots;
  LifeCycleManager m_sdLifeCycleManager;
  transient boolean m_bIsModified;

  String m_sDetail;



  public RegistryObject() {
  }

  public void setDescription(String para) {m_sDescription = para;}
  public String getDescription() {return m_sDescription;}

  public void setID(String para) {m_sID = para;}
  public String getID() {return m_sID;}

  public void setName(String para) {m_sName = para;}
  public String getName() {return m_sName;}

  public void setObjectType(String para) {m_sObjectType = para;}
  public String getObjectType() {return m_sObjectType;}

  public void setTypeString(String para) {m_sTypeString = para;}
  public String getTypeString() {return m_sTypeString;}


  public LifeCycleManager getLifeCycleManager() {
    return m_sdLifeCycleManager;
  }
  public void setLifeCycleManager(LifeCycleManager lifecyclemanager){
    m_sdLifeCycleManager = lifecyclemanager;
  }

  public boolean isModified() {return m_bIsModified;}
  public void setIsModified(boolean flag) {m_bIsModified = flag;}

  public void setDetail(String para) {m_sDetail = para;}
  public String getDetail() {return m_sDetail;}

  public String getSlotValue(String n) {
    if(slots != null) {
      return (String)slots.get(n);
    }
    return null;
  }

  public void setSlotValue(String n, String v) {
    if(slots == null)
      slots = new Hashtable();
    slots.put(n, v);
  }

}